const long fivem = 900000L; // 15 Minutes
const long twentys = 30000L; // 30 Seconds
const long fives = 5000L;  // 5 Seconds

unsigned long start;
unsigned long warning;

void resetStart(){
  start = millis();  
};

void setup() {
  pinMode(PD5, OUTPUT); // Pi
  pinMode(PD3, INPUT_PULLUP); // Button
  pinMode(PD7, OUTPUT); // LED
  start = millis()-fivem;
  attachInterrupt(digitalPinToInterrupt(3), resetStart, LOW); // Attach ISR
}

void loop() {
  if(millis()-start < fivem){ // Check if we should do anything
    digitalWrite(PD5, HIGH); // Power on Pi
    digitalWrite(PD7, HIGH); // Power on LED
    
    while(millis()-start < fivem){} // Loop for five minutes
  
    warning = millis(); // Show first warning sequence for 20 seconds
    while(millis()-warning < twentys && millis()-start >= fivem){
      digitalWrite(PD7, LOW);
      delay(1000);
      digitalWrite(PD7, HIGH);
      delay(1000);
      }
      
    warning = millis(); // Show second warning sequence for 5 seconds
    while(millis() - warning < fives && millis()-start >= fivem){
      digitalWrite(PD7, LOW);
      delay(400);
      digitalWrite(PD7, HIGH);
      delay(400);
      }
  
    if(millis()-start >= fivem){ // If the timer has not been reset power everything off
      digitalWrite(PD5, LOW);
      digitalWrite(PD7, LOW);
      }
    }
}
